Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_Condition_Thread_Mutex Class Reference

ACE_Condition variable wrapper written using ACE_Mutexes This allows threads to block until shared data changes state. A condition variable enables threads to atomically block and test the condition under the protection of a mutual exclu- sion lock (mutex) until the condition is satisfied. That is, the mutex must have been held by the thread before calling wait or signal on the condition. If the condition is false, a thread blocks on a condition variable and atomically releases the mutex that is waiting for the condition to change. If another thread changes the condition, it may wake up waiting threads by signaling the associated condition variable. The waiting threads, upon awakening, reacquire the mutex and re-evaluate the condition. More...

`#include <Synch.h>`

Collaboration diagram for ACE_Condition_Thread_Mutex:

[legend]
List of all members.

## Public Methods
| ACE_Condition_Thread_Mutex (const ACE_Thread_Mutex &m, const ACE_TCHAR *name=0, void *arg=0)
| Initialize the condition variable. More...
| ACE_Condition_Thread_Mutex (const ACE_Thread_Mutex &m, ACE_Condition_Attributes &attributes, const ACE_TCHAR *name=0, void *arg=0)
| Initialize the condition variable. More...
| ~ACE_Condition_Thread_Mutex (void)
| Implicitly destroy the condition variable. More...
int | remove (void)
| Explicitly destroy the condition variable. More...
int | wait (const ACE_Time_Value *abstime)
| Block on condition, or until absolute time-of-day has passed. More...
int | wait (void)
| Block on condition. More...
int | wait (ACE_Thread_Mutex &mutex, const ACE_Time_Value *abstime=0)
| Block on condition or until absolute time-of-day has passed. More...
int | signal (void)
| Signal one waiting thread. More...
int | broadcast (void)
| Signal *all* waiting threads. More...
ACE_Thread_Mutex & | mutex (void)
| Returns a reference to the underlying mutex;. More...
void | dump (void) const
| Dump the state of an object. More...
## Public Attributes
| ACE_ALLOC_HOOK_DECLARE
| Declare the dynamic allocation hooks. More...
## Protected Attributes
ACE_cond_t | cond_
| Condition variable. More...
ACE_Thread_Mutex & | mutex_
| Reference to mutex lock. More...
int | removed_
| Keeps track of whether <remove> has been called yet to avoid multiple <remove> calls, e.g., explicitly and implicitly in the destructor. This flag isn't protected by a lock, so make sure that you don't have multiple threads simultaneously calling <remove> on the same object, which is a bad idea anyway... More...
## Private Methods
void | operator= (const ACE_Condition_Thread_Mutex &)
| ACE_Condition_Thread_Mutex (const ACE_Condition_Thread_Mutex &)

## Detailed Description

ACE_Condition variable wrapper written using ACE_Mutexes This allows threads to block until shared data changes state. A condition variable enables threads to atomically block and test the condition under the protection of a mutual exclu- sion lock (mutex) until the condition is satisfied. That is, the mutex must have been held by the thread before calling wait or signal on the condition. If the condition is false, a thread blocks on a condition variable and atomically releases the mutex that is waiting for the condition to change. If another thread changes the condition, it may wake up waiting threads by signaling the associated condition variable. The waiting threads, upon awakening, reacquire the mutex and re-evaluate the condition.

This should be an instantiation of ACE_Condition but problems with compilers precludes this...

## Constructor & Destructor Documentation

ACE_Condition_Thread_Mutex::ACE_Condition_Thread_Mutex | ( | const ACE_Thread_Mutex & | m,
|  | const ACE_TCHAR * | name = 0,
|  | void * | arg = 0
| ) |

| Initialize the condition variable.

ACE_Condition_Thread_Mutex::ACE_Condition_Thread_Mutex | ( | const ACE_Thread_Mutex & | m,
|  | ACE_Condition_Attributes & | attributes,
|  | const ACE_TCHAR * | name = 0,
|  | void * | arg = 0
| ) |

| Initialize the condition variable.

ACE_Condition_Thread_Mutex::~ACE_Condition_Thread_Mutex | ( | void |  | ) |

| Implicitly destroy the condition variable.

ACE_Condition_Thread_Mutex::ACE_Condition_Thread_Mutex | ( | const ACE_Condition_Thread_Mutex & |  | ) | `[private]`

## Member Function Documentation

int ACE_Condition_Thread_Mutex::broadcast | ( | void |  | ) |

| Signal *all* waiting threads.

void ACE_Condition_Thread_Mutex::dump | ( | void |  | ) | const

| Dump the state of an object.

ACE_Thread_Mutex& ACE_Condition_Thread_Mutex::mutex | ( | void |  | ) |

| Returns a reference to the underlying mutex;.

void ACE_Condition_Thread_Mutex::operator= | ( | const ACE_Condition_Thread_Mutex & |  | ) | `[private]`

int ACE_Condition_Thread_Mutex::remove | ( | void |  | ) |

| Explicitly destroy the condition variable. Note that only one thread should call this method since it doesn't protect against race conditions.

int ACE_Condition_Thread_Mutex::signal | ( | void |  | ) |

| Signal one waiting thread.

int ACE_Condition_Thread_Mutex::wait | ( | ACE_Thread_Mutex & | mutex,
|  | const ACE_Time_Value * | abstime = 0
| ) |

| Block on condition or until absolute time-of-day has passed. If abstime == 0 use "blocking" wait() semantics on the <mutex> passed as a parameter (this is useful if you need to store the <Condition> in shared memory). Else, if <abstime> != 0 and the call times out before the condition is signaled <wait> returns -1 and sets errno to ETIME.

int ACE_Condition_Thread_Mutex::wait | ( | void |  | ) |

| Block on condition.

int ACE_Condition_Thread_Mutex::wait | ( | const ACE_Time_Value * | abstime | ) |

| Block on condition, or until absolute time-of-day has passed. If abstime == 0 use "blocking" <wait> semantics. Else, if <abstime> != 0 and the call times out before the condition is signaled <wait> returns -1 and sets errno to ETIME.

## Member Data Documentation

ACE_Condition_Thread_Mutex::ACE_ALLOC_HOOK_DECLARE

| Declare the dynamic allocation hooks.

ACE_cond_t ACE_Condition_Thread_Mutex::cond_`[protected]`

| Condition variable.

ACE_Thread_Mutex& ACE_Condition_Thread_Mutex::mutex_`[protected]`

| Reference to mutex lock.

int ACE_Condition_Thread_Mutex::removed_`[protected]`

| Keeps track of whether <remove> has been called yet to avoid multiple <remove> calls, e.g., explicitly and implicitly in the destructor. This flag isn't protected by a lock, so make sure that you don't have multiple threads simultaneously calling <remove> on the same object, which is a bad idea anyway...

The documentation for this class was generated from the following files:

- Synch.h
- Synch.cpp